import {
  LoggerNodeHandler
} from "./chunk-L7JCAZNH.js";
import {
  LoggerFileHandler
} from "./chunk-KUX7SJU5.js";
import {
  toPath
} from "./chunk-O4Q4BYEO.js";
import {
  getGlobalLogger
} from "./chunk-RVBBTDXC.js";
import {
  valueToBoolean
} from "./chunk-ABE65FZK.js";

// src/node/log/log-context-node.ts
import process from "node:process";
function Logger(name, level) {
  return getGlobalLogger((context) => {
    const handlers = [
      LoggerNodeHandler({
        padding: 32,
        nameBrackets: false
        // levelHelper: false,
      })
    ];
    const logFilePath = process.env.ZEED_LOG ?? process.env.LOG;
    const time = valueToBoolean(process.env.ZEED_TIME, true);
    const pretty = valueToBoolean(process.env.ZEED_PRETTY, false);
    if (logFilePath)
      handlers.unshift(LoggerFileHandler(toPath(logFilePath), { time, pretty }));
    context.setHandlers(handlers);
  })(name, level);
}

export {
  Logger
};
//# sourceMappingURL=chunk-NOE63MKA.js.map