import {
  useMessageHub
} from "../../chunk-V3BZKLCF.js";
import {
  CryptoEncoder
} from "../../chunk-HKU7TFOW.js";
import {
  createLocalChannelPair
} from "../../chunk-VPSEGLHI.js";
import "../../chunk-6DVQ64MF.js";
import "../../chunk-Y63XYRPN.js";
import "../../chunk-UMFGZFFE.js";
import "../../chunk-7GOLOL5D.js";
import "../../chunk-RXQQW2PV.js";
import "../../chunk-RVBBTDXC.js";
import "../../chunk-VSJ34R4O.js";
import "../../chunk-QXMTSRRE.js";
import "../../chunk-CFICINSP.js";
import {
  deriveKeyPbkdf2,
  randomUint8Array
} from "../../chunk-LKKRBQRQ.js";
import "../../chunk-I45WP5PM.js";
import "../../chunk-MZ2ODZKK.js";
import "../../chunk-ER2NNANC.js";
import "../../chunk-EJVKADTL.js";
import "../../chunk-UHTVWILC.js";
import "../../chunk-T7PU5CTZ.js";
import "../../chunk-XSB2WAW2.js";
import "../../chunk-AS5LR4AI.js";
import "../../chunk-5Y3HYG6B.js";
import "../../chunk-AFUVZLZZ.js";
import "../../chunk-WWSHZF6M.js";
import "../../chunk-NYCGHEIN.js";
import "../../chunk-S7CUSMDX.js";
import "../../chunk-FL5CT6MC.js";
import "../../chunk-2HWPZ6ZE.js";
import "../../chunk-HLRQ5H3N.js";
import "../../chunk-5J5P77E5.js";
import "../../chunk-G73H5WQB.js";
import "../../chunk-DGP32WEQ.js";
import "../../chunk-73CVRDI7.js";
import "../../chunk-ABE65FZK.js";
import "../../chunk-4XPO57AQ.js";
import "../../chunk-ACZDEHYB.js";
import "../../chunk-FSDCRQB3.js";
import "../../chunk-YEEGQOIW.js";
import "../../chunk-TWPB455K.js";
import "../../chunk-IZT6OHMS.js";
import "../../chunk-JU2MYLJO.js";
import "../../chunk-NS4INNCL.js";
import "../../chunk-TYWNSO7K.js";
import "../../chunk-ZMFW3O35.js";
import "../../chunk-5MAHDO36.js";
import "../../chunk-7NSVDPHN.js";
import "../../chunk-VVNSHVPQ.js";
import "../../chunk-6GHO7LQW.js";

// src/common/msg/messages.spec.ts
describe("messages", () => {
  it("should show the magic of proxies ", async () => {
    const p = new Proxy({}, {
      get(_target, _name) {
        return (...args) => {
          return args[0] ?? 0;
        };
      }
    });
    expect(await p.ping(await p.ping(2))).toBe(2);
  });
  it("should do hub thing", async () => {
    const key = await deriveKeyPbkdf2(randomUint8Array(20));
    const encoder = new CryptoEncoder(key);
    const [clientChannel, serverChannel] = createLocalChannelPair();
    const serverHub = useMessageHub({ channel: serverChannel, encoder });
    serverHub.listen({
      async ping(value) {
        expect(value).toBe(2);
        return value;
      }
    });
    serverHub.listen({
      async aping(value) {
        return new Promise((resolve) => setTimeout(() => resolve(value), 500));
      }
    });
    const clientHub = useMessageHub({ channel: clientChannel, encoder });
    const client = clientHub.send();
    const x = await client.aping(1);
    const y = await client.aping("H\xE4llo W\u{1F468}\u200D\u{1F469}\u200D\u{1F467}\u200D\u{1F466}rld");
    expect(x).toBe(1);
    expect(y).toBe("H\xE4llo W\u{1F468}\u200D\u{1F469}\u200D\u{1F467}\u200D\u{1F466}rld");
    await client.ping(2);
  });
});
//# sourceMappingURL=messages.spec.js.map